SystemOrganization addCategory: #'Rest-Example'!

RestEntity subclass: #Book
	instanceVariableNames: 'author title dueDate customer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Example'!

!Book class methodsFor: 'accessing' stamp: 'cs 5/20/2009 15:37'!
handlerClass
	self shouldBeImplemented! !

!Book class methodsFor: 'instance creation' stamp: 'cs 5/19/2009 19:03'!
newFrom: aDictionary

	^ self new
		author: (aDictionary at: 'author' ifAbsent: []);
		title: (aDictionary at: 'title')! !

!Book class methodsFor: 'description' stamp: 'cs 5/19/2009 19:04'!
primitivePropertyNames

	^ super primitivePropertyNames, #(author title dueDate)! !

!Book class methodsFor: 'description' stamp: 'cs 5/20/2009 15:32'!
referencePropertyNames

	^ super referencePropertyNames, #(customer)! !

!Book methodsFor: 'accessing' stamp: 'cs 5/19/2009 18:43'!
author

	^ author! !

!Book methodsFor: 'accessing' stamp: 'cs 5/19/2009 18:43'!
author: anObject

	author := anObject.! !

!Book methodsFor: 'accessing' stamp: 'cs 5/20/2009 15:32'!
customer

	^ customer! !

!Book methodsFor: 'accessing' stamp: 'cs 5/20/2009 15:36'!
customer: aCustomer

	self customer = aCustomer ifTrue: [^ self]. "to avoid infinite recursion"
	self customer ifNotNil:
		[self customer removeBorrowedBook: self].
	customer := aCustomer.
	self customer ifNotNil:
		[self customer addSecondLevelTestObject: self].! !

!Book methodsFor: 'deleting' stamp: 'cs 5/20/2009 15:38'!
delete
	
	self customer removeBorrowedBook: self.! !

!Book methodsFor: 'accessing' stamp: 'cs 5/19/2009 18:43'!
dueDate

	^ dueDate! !

!Book methodsFor: 'accessing' stamp: 'cs 5/19/2009 18:43'!
dueDate: anObject

	dueDate := anObject.! !

!Book methodsFor: 'accessing' stamp: 'cs 5/19/2009 18:43'!
title

	^ title! !

!Book methodsFor: 'accessing' stamp: 'cs 5/19/2009 18:43'!
title: anObject

	title := anObject.! !

RestEntity subclass: #Customer
	instanceVariableNames: 'firstname lastname borrowedBooks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Example'!

Customer class
	instanceVariableNames: 'customers'!

Customer class
	instanceVariableNames: 'customers'!

!Customer class methodsFor: 'add-remove' stamp: 'cs 5/20/2009 13:22'!
addCustomer: aCustomer

	self customers add: aCustomer.
	^ aCustomer id: self incrementId! !

!Customer class methodsFor: 'add-remove' stamp: 'cs 5/20/2009 13:23'!
addNewCustomer: aCustomer

	^ self addCustomer: (self newFrom: aCustomer)! !

!Customer class methodsFor: 'accessing' stamp: 'cs 5/20/2009 13:19'!
all

	^ self customers! !

!Customer class methodsFor: 'description' stamp: 'cs 5/19/2009 17:58'!
collectionPropertyNames

	^ super collectionPropertyNames, #(borrowedBooks)! !

!Customer class methodsFor: 'accessing' stamp: 'cs 5/20/2009 13:04'!
customers

	^ customers! !

!Customer class methodsFor: 'accessing' stamp: 'cs 5/20/2009 13:04'!
customers: anObject

	customers := anObject.! !

!Customer class methodsFor: 'accessing' stamp: 'cs 5/20/2009 15:12'!
handlerClass
	self shouldBeImplemented! !

!Customer class methodsFor: 'instance creation' stamp: 'cs 5/19/2009 18:56'!
newFrom: aDictionary

	^ self new
		firstname: (aDictionary at: 'firstname');
		lastname: (aDictionary at: 'lastname')! !

!Customer class methodsFor: 'description' stamp: 'cs 5/19/2009 19:03'!
primitivePropertyNames

	^ super primitivePropertyNames, #(firstname lastname)! !

!Customer class methodsFor: 'add-remove' stamp: 'cs 5/20/2009 15:16'!
removeCustomer: aCustomer
	
	^ self customers remove: aCustomer! !

!Customer methodsFor: 'add-remove' stamp: 'cs 5/20/2009 15:33'!
addBorrowedBook: aBook

	self borrowedBooks add: aBook ifPresent: [^ aBook].
	^ aBook
		id: aBook class incrementId;
		customer: self;
		yourself! !

!Customer methodsFor: 'add-remove' stamp: 'cs 5/20/2009 14:53'!
addNewBorrowedBook: aDictionary

	^ self addBorrowedBook: (Book newFrom: aDictionary)! !

!Customer methodsFor: 'accessing' stamp: 'cs 5/19/2009 17:56'!
borrowedBooks

	^ borrowedBooks! !

!Customer methodsFor: 'accessing' stamp: 'cs 5/19/2009 17:56'!
borrowedBooks: anObject

	borrowedBooks := anObject.! !

!Customer methodsFor: 'deleting' stamp: 'cs 5/20/2009 15:17'!
delete

	self class removeCustomer: self.! !

!Customer methodsFor: 'accessing' stamp: 'cs 5/19/2009 17:56'!
firstname

	^ firstname! !

!Customer methodsFor: 'accessing' stamp: 'cs 5/19/2009 17:56'!
firstname: anObject

	firstname := anObject.! !

!Customer methodsFor: 'accessing' stamp: 'cs 5/19/2009 17:56'!
lastname

	^ lastname! !

!Customer methodsFor: 'accessing' stamp: 'cs 5/19/2009 17:56'!
lastname: anObject

	lastname := anObject.! !

!Customer methodsFor: 'add-remove' stamp: 'cs 5/20/2009 15:33'!
removeBorrowedBook: aBook

	self borrowedBooks remove: aBook ifAbsent: [^ aBook].
	^ aBook
		customer: nil;
		yourself! !

RestResourceHttpHandler subclass: #LibraryResourceHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Example'!

!LibraryResourceHttpHandler class methodsFor: 'testing' stamp: 'cs 5/20/2009 19:33'!
canBeAutostarted

	^ true! !

!LibraryResourceHttpHandler class methodsFor: 'resources' stamp: 'cs 5/20/2009 17:11'!
rootResources

	^ Dictionary with: 'customer' -> Customer! !

!LibraryResourceHttpHandler class methodsFor: 'resources' stamp: 'cs 5/20/2009 19:33'!
uriMapping
	
	^ Dictionary
		with: Customer -> [:customer | '/customer/', customer id]
		with: Book -> [:book | book customer restUri, '/', book id]! !
